| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Ogre::Resource Class Referenceabstract
Core » Resources

Abstract class representing a loadable resource (e.g. More...

`#include <OgreResource.h>`

Inheritance diagram for Ogre::Resource:
[legend]

## Classes
class | Listener

## Public Types
enum | LoadingFlags { LF_DEFAULT = 0, LF_INCLUDE_NON_RELOADABLE = 1, LF_ONLY_UNREFERENCED = 2, LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3, LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING, LOADSTATE_PREPARED, LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...

## Public Member Functions
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor. More...
virtual | ~Resource ()
| Virtual destructor. More...
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed. More...
void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event. More...
void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event. More...
void | _fireUnloadingComplete (void)
| Firing of unloading complete event. More...
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin. More...
virtual void | addListener (Listener *lis)
| Register a listener on this resource. More...
virtual size_t | calculateSize (void) const
| Calculate the size of a resource; this will only be called after 'load'. More...
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource. More...
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource. More...
ResourceManager * | getCreator (void)
| Gets the manager which created this resource. More...
virtual const String & | getGroup (void) const
| Gets the group which this resource is a member of. More...
virtual ResourceHandle | getHandle (void) const
virtual LoadingState | getLoadingState () const
| Returns the current loading state. More...
virtual const String & | getName (void) const
| Gets resource name. More...
const String & | getOrigin (void) const
| Get the origin of this resource, e.g. More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
virtual size_t | getSize (void) const
| Retrieves info about the size of the resource. More...
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded. More...
virtual bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading. More...
virtual bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise. More...
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading. More...
virtual bool | isManuallyLoaded (void) const
| Is this resource manually loaded? More...
virtual bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise. More...
virtual bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise. More...
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already. More...
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already. More...
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded. More...
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource. More...
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not. More...
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used. More...
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...

## Public Attributes
| OGRE_AUTO_MUTEX

## Detailed Description

Abstract class representing a loadable resource (e.g.

textures, sounds etc)

Remarks
  Resources are data objects that must be loaded and managed throughout an application. A resource might be a mesh, a texture, or any other piece of data - the key thing is that they must be identified by a name which is unique, must be loaded only once, must be managed efficiently in terms of retrieval, and they may also be unloadable to free memory up when they have not been used for a while and the memory budget is under stress.

  All Resource instances must be a member of a resource group; see ResourceGroupManager for full details.

  Subclasses must implement:
  1. A constructor, overriding the same parameters as the constructor defined by this class. Subclasses are not allowed to define constructors with other parameters; other settings must be settable through accessor methods before loading.
  2. The loadImpl() and unloadImpl() methods - mSize must be set after loadImpl()
  3. StringInterface ParamCommand and ParamDictionary setups in order to allow setting of core parameters (prior to load) through a generic interface.

## Member Enumeration Documentation

## ◆ LoadingState

enum Ogre::Resource::LoadingState

Enum identifying the loading state of the resource.

Enumerator
LOADSTATE_UNLOADED | Not loaded.
LOADSTATE_LOADING | Loading is in progress.
LOADSTATE_LOADED | Fully loaded.
LOADSTATE_UNLOADING | Currently unloading.
LOADSTATE_PREPARED | Fully prepared.
LOADSTATE_PREPARING | Preparing is in progress.

## ◆ LoadingFlags

enum Ogre::Resource::LoadingFlags

Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior.

Enumerator
LF_DEFAULT | Only reloadable resources are processed, reload restores initial state.
LF_INCLUDE_NON_RELOADABLE | Process non-reloadable resources too.
LF_ONLY_UNREFERENCED | Process only resources which are not referenced by any other object. Usefull to reduce resource consumption.
LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE | Combination of LF_ONLY_UNREFERENCED and LF_INCLUDE_NON_RELOADABLE.
LF_PRESERVE_STATE | Preserve some states during reloading, for example stencil shadows prepareness for Meshes.

## Constructor & Destructor Documentation

## ◆ Resource()

Ogre::Resource::Resource | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`
| ) |  |

Standard constructor.

Parameters

  creator | Pointer to the ResourceManager that is creating this resource
  name | The unique name of the resource
  group | The name of the resource group to which this resource belongs
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualResourceLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualResourceLoader instance is strongly recommended.

## ◆ ~Resource()

virtual Ogre::Resource::~Resource | ( |  | ) |
| virtual

Virtual destructor.

Shouldn't need to be overloaded, as the resource deallocation code should reside in unload()

See also
  Resource::unload()

## Member Function Documentation

## ◆ prepare()

virtual void Ogre::Resource::prepare | ( | bool | backgroundThread = `false` | ) |
| virtual

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

Parameters

  backgroundThread | Whether this is occurring in a background thread

## ◆ load()

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) |
| virtual

Loads the resource, if it is not already.

Remarks
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters

  backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ reload()

virtual void Ogre::Resource::reload | ( | LoadingFlags | flags = `LF_DEFAULT` | ) |
| virtual

Reloads the resource, if it is already loaded.

Remarks
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::Mesh, and Ogre::UnifiedHighLevelGpuProgram.

## ◆ isReloadable()

virtual bool Ogre::Resource::isReloadable | ( | void |  | ) | const
| inline virtual

Returns true if the Resource is reloadable, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isManuallyLoaded()

virtual bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const
| inline virtual

Is this resource manually loaded?

## ◆ unload()

virtual void Ogre::Resource::unload | ( | void |  | ) |
| virtual

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getSize()

virtual size_t Ogre::Resource::getSize | ( | void |  | ) | const
| inline virtual

Retrieves info about the size of the resource.

Reimplemented in Ogre::CgProgram, and Ogre::UnifiedHighLevelGpuProgram.

## ◆ touch()

virtual void Ogre::Resource::touch | ( | void |  | ) |
| virtual

'Touches' the resource to indicate it has been used.

Reimplemented in Ogre::Material, Ogre::CgProgram, and Ogre::UnifiedHighLevelGpuProgram.

Referenced by Ogre::Material::touch().

## ◆ getName()

virtual const String& Ogre::Resource::getName | ( | void |  | ) | const
| inline virtual

Gets resource name.

Reimplemented in Ogre::SkeletonInstance.

Referenced by Ogre::GpuProgramUsage::getProgramName(), and OgreBites::TrayManager::resourceLoadStarted().

## ◆ getHandle()

virtual ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const
| inline virtual

Reimplemented in Ogre::SkeletonInstance.

## ◆ isPrepared()

virtual bool Ogre::Resource::isPrepared | ( | void |  | ) | const
| inline virtual

Returns true if the Resource has been prepared, false otherwise.

## ◆ isLoaded()

virtual bool Ogre::Resource::isLoaded | ( | void |  | ) | const
| inline virtual

Returns true if the Resource has been loaded, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isLoading()

virtual bool Ogre::Resource::isLoading | ( |  | ) | const
| inline virtual

Returns whether the resource is currently in the process of background loading.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getLoadingState()

virtual LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const
| inline virtual

Returns the current loading state.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isBackgroundLoaded()

virtual bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const
| inline virtual

Returns whether this Resource has been earmarked for background loading.

Remarks
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ setBackgroundLoaded()

virtual void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) |
| inline virtual

Tells the resource whether it is background loaded or not.

See also
  Resource::isBackgroundLoaded. Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ escalateLoading()

virtual void Ogre::Resource::escalateLoading | ( |  | ) |
| virtual

Escalates the loading of a background loaded resource.

Remarks
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ addListener()

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) |
| virtual

Register a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ removeListener()

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) |
| virtual

Remove a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getGroup()

virtual const String& Ogre::Resource::getGroup | ( | void |  | ) | const
| inline virtual

Gets the group which this resource is a member of.

Reimplemented in Ogre::SkeletonInstance.

## ◆ changeGroupOwnership()

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) |
| virtual

Change the resource group ownership of a Resource.

Remarks
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters

  newGroup | Name of the new group

## ◆ getCreator()

ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) |
| inline

Gets the manager which created this resource.

## ◆ getOrigin()

const String& Ogre::Resource::getOrigin | ( | void |  | ) | const
| inline

Get the origin of this resource, e.g.

a script file name.

Remarks
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

## ◆ _notifyOrigin()

void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) |
| inline

Notify this resource of it's origin.

## ◆ getStateCount()

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const
| inline virtual

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

## ◆ _dirtyState()

virtual void Ogre::Resource::_dirtyState | ( |  | ) |
| virtual

Manually mark the state of this resource as having been changed.

Remarks
  You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also
  getStateCount.

## ◆ _fireLoadingComplete()

void Ogre::Resource::_fireLoadingComplete | ( | bool | wasBackgroundLoaded | ) |

Firing of loading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _firePreparingComplete()

void Ogre::Resource::_firePreparingComplete | ( | bool | wasBackgroundLoaded | ) |

Firing of preparing complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _fireUnloadingComplete()

void Ogre::Resource::_fireUnloadingComplete | ( | void |  | ) |

Firing of unloading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

## ◆ calculateSize()

virtual size_t Ogre::Resource::calculateSize | ( | void |  | ) | const
| virtual

Calculate the size of a resource; this will only be called after 'load'.

Reimplemented in Ogre::GpuProgram, Ogre::HighLevelGpuProgram, Ogre::GLSLESProgram, Ogre::UnifiedHighLevelGpuProgram, Ogre::GLSLShader, and Ogre::GLGpuProgram.

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inline inherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inline inherited

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ setParameter()

bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| inherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| inherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ getParameter()

String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inline inherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ copyParametersTo()

void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inline inherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| static inherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## Member Data Documentation

## ◆ OGRE_AUTO_MUTEX

Ogre::Resource::OGRE_AUTO_MUTEX

The documentation for this class was generated from the following file:

- OgreResource.h